////////////////////////////////////////////////////////////////////////////////
//
//
//  FileName    :   Skin2Define.pas
//  Creator     :   Shen Min
//  Date        :   2006-02-23
//  Comment     :
//
//  Copyright (c) 2002-2006 Sunisoft
//  http://www.sunisoft.com
//  Email: support@sunisoft.com
//
////////////////////////////////////////////////////////////////////////////////

unit SUI2Define;

interface

type
    Tsk2SkinColorElement = (
        SKIN2_TRANSCOLOR,
        SKIN2_TITLEFONTCOLOR,
        SKIN2_FORMCOLOR,
        SKIN2_MENUBARSTARTCOLOR,
        SKIN2_MENUBARENDCOLOR,
        SKIN2_TOPSELECTEDMENUCOLOR,
        SKIN2_TOPSELECTEDMENUBORDERCOLOR,
        SKIN2_TOPSELECTEDMENUFONTCOLOR,
        SKIN2_TOPMENUFONTCOLOR,
        SKIN2_LEFTBARSTARTCOLOR,
        SKIN2_LEFTBARENDCOLOR,
        SKIN2_MENUITEMCOLOR,
        SKIN2_MENUITEMFONTCOLOR,
        SKIN2_SELECTEDMENUCOLOR,
        SKIN2_SELECTEDMENUBORDERCOLOR,
        SKIN2_SELECTEDMENUFONTCOLOR,
        SKIN2_TOOLBARSTARTCOLOR,
        SKIN2_TOOLBARENDCOLOR,
        SKIN2_TOOLBARONCOLOR,
        SKIN2_TOOLBARBORDERCOLOR,
        SKIN2_TOOLBARDOWNCOLOR,
        SKIN2_CONTROLCOLOR,
        SKIN2_CONTROLBORDERCOLOR,
        SKIN2_CONTROLFONTCOLOR,
        SKIN2_BUTTONFONTCOLOR,
        SKIN2_SCROLLBARCOLOR,
        SKIN2_TABCONTROLCOLOR,
        SKIN2_TABCONTROLBORDERCOLOR,
        SKIN2_TABCONTROLACTIVEFONTCOLOR,
        SKIN2_TABCONTROLINACTIVEFONTCOLOR,
        SKIN2_SIDECHANNELCOLOR,
        SKIN2_SIDECHANNELBORDERCOLOR
    );

    Tsk2SkinBitmapElement = (
        SKIN2_TITLEBAR1,
        SKIN2_TITLEBAR2,
        SKIN2_TITLEBAR3,
        SKIN2_TITLEBAR4,
        SKIN2_TITLEBAR5,
        SKIN2_FORMLEFTBORDER,
        SKIN2_FORMRIGHTBORDER,
        SKIN2_FORMBOTTOMBORDER1,
        SKIN2_FORMBOTTOMBORDER2,
        SKIN2_FORMBOTTOMBORDER3,
        SKIN2_MINIMIZEDTITLE,
        SKIN2_TITLEBUTTONS,
        SKIN2_CHECKEDMENUICON,
        SKIN2_MENUBAR,
        SKIN2_TOOLBAR,
        SKIN2_BUTTON,
        SKIN2_CHECKBOX,
        SKIN2_CHECKBOXLIST,
        SKIN2_RADIOBUTTON,
        SKIN2_PROGRESSBAR1,
        SKIN2_PROGRESSBAR2,
        SKIN2_PROGRESSBAR3,
        SKIN2_PROGRESSBAR4,
        SKIN2_TRACKBAR,
        SKIN2_TRACKBARSLIDER,
        SKIN2_TRACKBARVSLIDER,
        SKIN2_SCROLLBARUPBUTTON,
        SKIN2_SCROLLBAR,
        SKIN2_SCROLLBARDOWNBUTTON,
        SKIN2_TABCONTROL,
        SKIN2_TABCONTROLLINE,
        SKIN2_SIDECHANNELBAR,
        SKIN2_SIDECHANNELTITLE,
        SKIN2_SCROLLBUTTON
    );

    Tsk2IntElement = (
        SKIN2_TITLEBARICONPOSX,
        SKIN2_TITLEBARICONPOSY,
        SKIN2_TITLEBARCAPTIONTOP,
        SKIN2_TITLEBARBUTTONPOSX,
        SKIN2_TITLEBARBUTTONPOSY,
        SKIN2_TITLEBARREGIONMINY,
        SKIN2_TITLEBARREGIONMAXY,
        SKIN2_BOTTOMREGIONMINY,
        SKIN2_BOTTOMREGIONMAXY
    );

    Tsk2BoolElement = (
        SKIN2_TITLEFIVESECT,
        SKIN2_BOTTOMBORDERTHREESECT,
        SKIN2_TITLEBARNEEDREGION,
        SKIN2_BOTTOMBORDERNEEDREGION,
        SKIN2_TITLEBTNTRANS,
        SKIN2_BUTTONTRANS,
        SKIN2_CHECKBOXTRANS,
        SKIN2_RADIOBUTTONTRANS,
        SKIN2_TABCONTROLTRANS
    );

const
    SKIN2_COLORELEMENT_OFFSET       = 0;
    SKIN2_BITMAPELEMENT_OFFSET      = SKIN2_COLORELEMENT_OFFSET + Ord(High(Tsk2SkinColorElement)) + 1;
    SKIN2_INTELEMENT_OFFSET         = SKIN2_BITMAPELEMENT_OFFSET + Ord(High(Tsk2SkinBitmapElement)) + 1;
    SKIN2_BOOLELEMENT_OFFSET        = SKIN2_INTELEMENT_OFFSET + Ord(High(Tsk2IntElement)) + 1;

    SKIN2_SKINFILE_KEYNAME : array [0..
        Ord(High(Tsk2SkinColorElement)) +
        Ord(High(Tsk2SkinBitmapElement)) +
        Ord(High(Tsk2IntElement)) +
        Ord(High(Tsk2BoolElement)) +
        4 - 1  // 4 types                
    ] of String = (
        'SKIN2_TRANSCOLOR',
        'SKIN2_TITLEFONTCOLOR',
        'SKIN2_FORMCOLOR',
        'SKIN2_MENUBARSTARTCOLOR',
        'SKIN2_MENUBARENDCOLOR',
        'SKIN2_TOPSELECTEDMENUCOLOR',
        'SKIN2_TOPSELECTEDMENUBORDERCOLOR',
        'SKIN2_TOPSELECTEDMENUFONTCOLOR',
        'SKIN2_TOPMENUFONTCOLOR',        
        'SKIN2_LEFTBARSTARTCOLOR',
        'SKIN2_LEFTBARENDCOLOR',
        'SKIN2_MENUITEMCOLOR',
        'SKIN2_MENUITEMFONTCOLOR',
        'SKIN2_SELECTEDMENUCOLOR',
        'SKIN2_SELECTEDMENUBORDERCOLOR',
        'SKIN2_SELECTEDMENUFONTCOLOR',
        'SKIN2_TOOLBARSTARTCOLOR',
        'SKIN2_TOOLBARENDCOLOR',
        'SKIN2_TOOLBARONCOLOR',
        'SKIN2_TOOLBARBORDERCOLOR',
        'SKIN2_TOOLBARDOWNCOLOR',
        'SKIN2_CONTROLCOLOR',
        'SKIN2_CONTROLBORDERCOLOR',
        'SKIN2_CONTROLFONTCOLOR',
        'SKIN2_BUTTONFONTCOLOR',
        'SKIN2_SCROLLBARCOLOR',
        'SKIN2_TABCONTROLCOLOR',
        'SKIN2_TABCONTROLBORDERCOLOR',
        'SKIN2_TABCONTROLACTIVEFONTCOLOR',
        'SKIN2_TABCONTROLINACTIVEFONTCOLOR',
        'SKIN2_SIDECHANNELCOLOR',
        'SKIN2_SIDECHANNELBORDERCOLOR',

        'SKIN2_TITLEBAR1',
        'SKIN2_TITLEBAR2',
        'SKIN2_TITLEBAR3',
        'SKIN2_TITLEBAR4',
        'SKIN2_TITLEBAR5',
        'SKIN2_FORMLEFTBORDER',
        'SKIN2_FORMRIGHTBORDER',
        'SKIN2_FORMBOTTOMBORDER1',
        'SKIN2_FORMBOTTOMBORDER2',
        'SKIN2_FORMBOTTOMBORDER3',
        'SKIN2_MINIMIZEDTITLE',
        'SKIN2_TITLEBUTTONS',
        'SKIN2_CHECKEDMENUICON',        
        'SKIN2_MENUBAR',
        'SKIN2_TOOLBAR',
        'SKIN2_BUTTON',
        'SKIN2_CHECKBOX',
        'SKIN2_CHECKBOXLIST',
        'SKIN2_RADIOBUTTON',
        'SKIN2_PROGRESSBAR1',
        'SKIN2_PROGRESSBAR2',
        'SKIN2_PROGRESSBAR3',
        'SKIN2_PROGRESSBAR4',
        'SKIN2_TRACKBAR',
        'SKIN2_TRACKBARSLIDER',
        'SKIN2_TRACKBARVSLIDER',
        'SKIN2_SCROLLBARUPBUTTON',
        'SKIN2_SCROLLBAR',
        'SKIN2_SCROLLBARDOWNBUTTON',
        'SKIN2_TABCONTROL',
        'SKIN2_TABCONTROLLINE',
        'SKIN2_SIDECHANNELBAR',
        'SKIN2_SIDECHANNELTITLE',
        'SKIN2_SCROLLBUTTON',

        'SKIN2_TITLEBARICONPOSX',
        'SKIN2_TITLEBARICONPOSY',
        'SKIN2_TITLEBARCAPTIONTOP',
        'SKIN2_TITLEBARBUTTONPOSX',
        'SKIN2_TITLEBARBUTTONPOSY',
        'SKIN2_TITLEBARREGIONMINY',
        'SKIN2_TITLEBARREGIONMAXY',
        'SKIN2_BOTTOMREGIONMINY',
        'SKIN2_BOTTOMREGIONMAXY',

        'SKIN2_TITLEFIVESECT',
        'SKIN2_BOTTOMBORDERTHREESECT',
        'SKIN2_TITLEBARNEEDREGION',
        'SKIN2_BOTTOMBORDERNEEDREGION',
        'SKIN2_TITLEBTNTRANS',
        'SKIN2_BUTTONTRANS',
        'SKIN2_CHECKBOXTRANS',
        'SKIN2_RADIOBUTTONTRANS',
        'SKIN2_TABCONTROLTRANS'
    );

implementation

end.
